precision mediump float;// highp here doesn't seem to matter
varying vec2 vTextureCoord;
uniform sampler2D sTexture;
uniform mat4 uColorMat;


float normpdf(in float x, in float sigma)
{
    return 0.39894*exp(-0.5*x*x/(sigma*sigma))/sigma;
}

vec4 blur(vec3 c,vec2 fragCoord,vec2 size)
{
    //declare stuff
    const int mSize = 11;
    const int kSize = (mSize-1)/2;
    float kernel[mSize];
    vec3 final_colour = vec3(0.0);

    //create the 1-D kernel
    float sigma = 7.0;
    float Z = 0.0;
    for (int j = 0; j <= kSize; ++j)
    {
        kernel[kSize+j] = kernel[kSize-j] = normpdf(float(j), sigma);
    }
    //get the normalization factor (as the gaussian has been clamped)
    for (int j = 0; j < mSize; ++j){
        Z += kernel[j];
    }

    //read out the texels
    for (int i=-kSize; i <= kSize; ++i){
        for (int j=-kSize; j <= kSize; ++j){
            vec3 temp = texture2D(sTexture,fragCoord.xy +vec2(float(i), float(j)) / size.xy).rgb;
            final_colour += kernel[kSize+j]*kernel[kSize+i]*temp;
        }
    }
    return vec4(final_colour/(Z*Z), 1.0);
}

void main() {
    vec3 c = texture2D(sTexture, vTextureCoord.xy).rgb;
    gl_FragColor = blur(c,vTextureCoord,vec2(540,960));
    gl_FragColor =uColorMat* gl_FragColor;
}