attribute vec4 position;
attribute vec4 inputTextureCoordinate;
const int GAUSSIAN_SAMPLES = 9;

uniform float texelWidthOffset;
uniform float texelHeightOffset;
uniform mat4 uSTMatrix;
uniform mat4 uMVPMatrix;
varying vec2 textureCoordinate;
varying vec2 blurCoordinates[GAUSSIAN_SAMPLES];

void main() {
    //gl_Position = position;
    //textureCoordinate = inputTextureCoordinate.xy;
    gl_Position = uMVPMatrix * position;
    textureCoordinate = (uSTMatrix * inputTextureCoordinate).xy;

                    	// Calculate the positions for the blur
    vec2 blurStep;
        for (int i = 0; i < GAUSSIAN_SAMPLES; i++){
             float row = floor(float(i)/5.0);
             float col = mod(float(i),5.0);

            // Blur in x (horizontal)
            blurStep.x = float(col - 2.0)*texelWidthOffset;
            blurStep.y = float(row - 2.0)*texelHeightOffset;
            blurCoordinates[i] = textureCoordinate.xy + blurStep;
        }
}