#extension GL_OES_EGL_image_external : require
 precision highp float;
 varying highp vec2 vTextureCoord;
 uniform int channel;
 uniform sampler2D inputImageTexture;
 void main()
 {
    vec3 fg = texture2D( inputImageTexture, vTextureCoord ).xyz;
	if(channel==1){
        float maxgb = max( fg.g, fg.b );
        float k = clamp( (fg.r-maxgb)*5.0, 0.0, 1.0 );
        float dr = fg.r;
        fg.r = min( fg.r, maxgb*0.8 );
        fg += dr - fg.r;
        gl_FragColor = vec4(fg, 1.0-k);
    }else if(channel==2){
        float maxrb = max( fg.r, fg.b );
        float k = clamp( (fg.g-maxrb)*5.0, 0.0, 1.0 );
        float dg = fg.g;
        fg.g = min( fg.g, maxrb*0.8 );
        fg += dg - fg.g;
        gl_FragColor = vec4(fg, 1.0-k );
    }else{
        float maxrg = max( fg.r, fg.g );
        float k = clamp( (fg.b-maxrg)*5.0, 0.0, 1.0 );
        float db = fg.b;
        fg.b = min( fg.b, maxrg*0.8 );
        fg += db - fg.b;
        gl_FragColor = vec4(fg, 1.0-k );
    }
 }