
precision mediump float;
 varying vec2 textureCoordinate;
 uniform sampler2D inputImageTexture;
 uniform float u_filterRatioH;
 uniform float texelWidthF;
 uniform float texelHeightF;
 uniform float sigma_c;
 uniform float sigma_s;
 vec4 clampForColor(vec4 color) {
    return clamp(color, vec4(0.0), vec4(1.0));
 }
 void main() {
    float constVal1 = 2.*sigma_c*sigma_c;
    float constVal2 = 2.*sigma_s*sigma_s;
    float sf = 0.0;
    vec3 sg = vec3(0., 0., 0.);
    vec3 after_filter;
    const int unit = 1;
    float wg;
    float g;
    float s;
    float f;
    int i;
    float possible;
    float sumdistance = 0.0;
    float edgeflag = 27.0/float(unit);
    vec3 irgb = texture2D(inputImageTexture, textureCoordinate).rgb;
    for (i = -unit;i <= unit;i++) {
        vec3 currgb = texture2D(inputImageTexture, textureCoordinate + vec2(i)*vec2(texelWidthF, texelHeightF)).rgb;
        wg = exp(-float(i*i)/constVal1);
        g = distance(currgb, irgb);
        s = exp(-g*g/constVal2);
        sumdistance+= g*g;
        f = s*wg;
        sf += f;
        sg += f*currgb;
    }
    after_filter = sg/sf;
    possible = 1.0 - clamp(sumdistance*edgeflag, 0.0,1.0);
    vec4 biResHori = vec4(mix(irgb, after_filter, possible), 1.0);
    gl_FragColor.rgb = mix(irgb.rgb, biResHori.rgb, u_filterRatioH);
    gl_FragColor.a = 1.0;
    //gl_FragColor = vec4(u_filterRatioH, 0,gl_FragColor.b,1.);
 }
