#extension GL_OES_EGL_image_external:require
precision mediump float;
uniform samplerExternalOES inputImageTexture;
varying vec2 textureCoordinate2;
varying vec2 textureCoordinate;
uniform float filterRatio;
uniform sampler2D map;
uniform sampler2D overlay;
uniform sampler2D blackboard;
void main() {
    vec4 texel = texture2D(inputImageTexture, textureCoordinate);
    vec4 inputTexel = texel;
    vec3 bbTexel = texture2D(blackboard, textureCoordinate2).rgb;
    texel.r = texture2D(overlay, vec2(bbTexel.r, texel.r)).r;
    texel.g = texture2D(overlay, vec2(bbTexel.g, texel.g)).g;
    texel.b = texture2D(overlay, vec2(bbTexel.b, texel.b)).b;
    vec3 mapped;
    mapped.r = texture2D(map, vec2(texel.r, .16666)).r;
    mapped.g = texture2D(map, vec2(texel.g, .5)).g;
    mapped.b = texture2D(map, vec2(texel.b, .83333)).b;
    texel.rgb = mapped;
    texel.rgb = mix(inputTexel.rgb, texel.rgb, filterRatio);
    gl_FragColor = texel;
 }