#extension GL_OES_EGL_image_external:require
precision highp float;
uniform samplerExternalOES inputImageTexture;
varying vec2 textureCoordinate;
uniform float filterRatio;
uniform sampler2D lookup;
vec4 ig_texture3D(sampler2D tex, vec3 texCoord, float size) { float sliceSize = 1.0 / size;
    float slicePixelSize = sliceSize / size;
    float sliceInnerSize = slicePixelSize * (size - 1.0);
    float xOffset = 0.5 * sliceSize + texCoord.x * (1.0 - sliceSize);
    float yOffset = 0.5 * slicePixelSize + texCoord.y * sliceInnerSize;
    float zOffset = texCoord.z * (size - 1.0);
    float zSlice0 = floor(zOffset);
    float zSlice1 = zSlice0 + 1.0;
    float s0 = yOffset + (zSlice0 * sliceSize);
    float s1 = yOffset + (zSlice1 * sliceSize);
    vec4 slice0Color = texture2D(tex, vec2(xOffset, s0));
    vec4 slice1Color = texture2D(tex, vec2(xOffset, s1));
    return mix(slice0Color, slice1Color, zOffset - zSlice0);
}
void main() {
    vec4 texel = texture2D(inputImageTexture, textureCoordinate);
    vec4 temp = texel;
    vec4 inputTexel = texel;
    texel.rgb = ig_texture3D(lookup, texel.rgb, 33.0).rgb;
    texel.rgb = mix(inputTexel.rgb, texel.rgb, filterRatio);
    gl_FragColor = texel;
    //gl_FragColor = vec4(temp.rgb,texel);
 }