#extension GL_OES_EGL_image_external:require
precision mediump float;
 varying vec2 textureCoordinate;
 varying vec2 textureCoordinate2;
 uniform samplerExternalOES inputImageTexture;
 uniform sampler2D inputImageTexture2;
 uniform int ph_MapB[256];
 uniform int ph_MapG[256];
 uniform int ph_MapR[256];
 uniform int ph_Flags[6];
 uniform float filterRatio;
vec4 DoOverlay(vec4 base, vec4 blend) {
    vec4 result;
    vec4 lumCoeff = vec4(0.0721, 0.7154, 0.2125, 0.0);
    vec4 white = vec4(1.0, 1.0, 1.0, 1.0);
    float luminance = dot(base, lumCoeff);
    if (luminance < 0.45) result = 2.0 * blend * base;
    else if (luminance > 0.55) result = white - 2.0 * (white - blend) * (white - base);
    else {
        vec4 result1 = 2.0 * blend * base;
        vec4 result2 = white - 2.0 * (white - blend) * (white - base);
        result = mix(result1, result2, (luminance - 0.45) * 10.0);
    }
    return result;
 }

float DoOverlayPerChannel(float baseVal, float blendVal) {
    float result;
    if(baseVal < 0.5) {
        result = 2.0 * baseVal * blendVal;
    } else result = 1.0 - 2.0 * (1.0 - baseVal) * (1.0 - blendVal);
    return result;
 }


void main() {
    vec4 dstColor = texture2D(inputImageTexture, textureCoordinate);
    float originalAlpha = dstColor.a;
    vec4 originalColor = dstColor;
    if(ph_Flags[0] > 0) {
        vec3 temp = dstColor.rgb * 255.0;
        ivec3 iDstColor = ivec3(temp);
        iDstColor.b = ph_MapB[iDstColor.b];
        iDstColor.g = ph_MapG[iDstColor.g];
        iDstColor.r = ph_MapR[iDstColor.r];
        dstColor = vec4(vec3(iDstColor)/255.0, 1.0);
    }
    int SumFlag = ph_Flags[1] + ph_Flags[2] + ph_Flags[3] + ph_Flags[4];
    if(SumFlag > 0) {
        vec4 blendColor = texture2D(inputImageTexture2, textureCoordinate2);
        vec4 srcVal = dstColor;
        if(ph_Flags[1] > 0) {
            dstColor.r = DoOverlayPerChannel(dstColor.r, blendColor.r);
            dstColor.g = DoOverlayPerChannel(dstColor.g, blendColor.g);
            dstColor.b = DoOverlayPerChannel(dstColor.b, blendColor.b);
        }
        if(ph_Flags[2] > 0) dstColor = dstColor * blendColor;
        if(ph_Flags[3] > 0) dstColor = 1.0 - ((1.0 - blendColor) * (1.0 - dstColor));
        if(ph_Flags[4] > 0) dstColor = mix(srcVal, dstColor, (float(ph_Flags[5])) / 256.0);
    } vec3 mapped = dstColor.rgb;
    gl_FragColor = vec4(mix(originalColor.rgb, mapped, filterRatio), originalAlpha);
}