#extension GL_OES_EGL_image_external:require
varying highp vec2 textureCoordinate;
uniform samplerExternalOES inputImageTexture;
uniform highp float filterRatio;
highp vec4 softlight(highp vec4 base, highp vec4 blend) {
    highp vec4 result = 2.0 * base * blend + base * base - 2.0 * base * base * blend;
    return result;
}

void main() {
    highp vec4 textureColor = texture2D(inputImageTexture, textureCoordinate);
    highp float luminance = dot(textureColor.rgb, vec3(0.212671, 0.71516, 0.072169));
    highp vec4 color = vec4(1.0, 1.0, 1.0, textureColor.a);
    color.r = (106.6 - 110.4 * cos(2.10095 * luminance) + 104.8 * sin(2.10095 * luminance)) / 255.0;
    color.g = (120.4 - 99.57 * cos(2.09661 * luminance) + 95.5 * sin(2.09661 * luminance)) / 255.0;
    color.b = (135.1 - 88.69 * cos(2.09151 * luminance) + 85.38 * sin(2.09151 * luminance)) / 255.0;
    color = softlight(color, color);
    gl_FragColor = mix(textureColor, color, filterRatio);
}