#extension GL_OES_EGL_image_external:require
precision highp float;
varying vec2 textureCoordinate;
uniform samplerExternalOES inputImageTexture;
uniform float filterRatio;
void main() {
    vec4 curColor = texture2D(inputImageTexture, textureCoordinate);
    float originalAlpha = curColor.a;
    vec3 color = curColor.rgb;
    vec3 Square = color * color;
    vec3 Cubic = Square * color;
    color.r = 8.558 * Cubic.r * Square.r - 21.13 * Square.r * Square.r + 14.5 * Cubic.r - 0.8 * Square.r - 0.2486 * color.r + 0.1123;
    color.g = -1.962 * Cubic.g + 3.456 * Square.g - 0.6664 * color.g + 0.1518;
    color.b = -0.04515 * Cubic.b + 0.5487 * Square.b + 0.05156 * color.b + 0.1492;
    vec3 temp = sqrt(color);
    color = mix(temp, color, 0.3725);
    gl_FragColor.rgb = mix(curColor.rgb, color, filterRatio);
    gl_FragColor.a = originalAlpha;
}