#extension GL_OES_EGL_image_external:require
precision mediump float;
varying vec2 textureCoordinate;
uniform samplerExternalOES inputImageTexture;
uniform int ph_DirectCurveMapBlue[256];
uniform int ph_DirectCurveMapGreen[256];
uniform int ph_DirectCurveMapRed[256];
uniform float filterRatio;
void main() {
    vec4 curColor = texture2D(inputImageTexture, textureCoordinate);
    vec4 originalColor = curColor;
    vec4 mapped;
    mapped.b = float(ph_DirectCurveMapBlue[int(255.0 * curColor.b)]) / 255.0;
    mapped.g = float(ph_DirectCurveMapGreen[int(255.0 * curColor.g)]) / 255.0;
    mapped.r = float(ph_DirectCurveMapRed[int(255.0 * curColor.r)]) / 255.0;
    mapped.a = curColor.a;
    gl_FragColor = mix(originalColor, mapped, filterRatio);
}